package strickling.forms;

// Generic class definition for a Date imput class
/* copy following lines into your new class

import com.my_package.R;        // ***** Correct your resource file

import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class Date_Input extends Date_Input_Class {
	
	
	// initViews will be called first from onCreate
	public void initViews (){
		setContentView(R.layout.date_input);
		jd_Text = (EditText) findViewById(R.id.JD_TEXT);
		etYear  = (EditText) findViewById(R.id.input1);
		etMon  	= (EditText) findViewById(R.id.input2);
		etDay  	= (EditText) findViewById(R.id.input3);
		etH  	= (EditText) findViewById(R.id.input4);
		etMin  	= (EditText) findViewById(R.id.input5);
		etSec  	= (EditText) findViewById(R.id.input6);
		etTZ  	= (EditText) findViewById(R.id.input7);
		datumsZeile= (TextView) findViewById(R.id.DateLine);
		btnArr [0] = (Button) findViewById(R.id.plusBtn1);
		btnArr [1] = (Button) findViewById(R.id.plusBtn2);
		btnArr [2] = (Button) findViewById(R.id.plusBtn3);
		btnArr [3] = (Button) findViewById(R.id.plusBtn4);
		btnArr [4] = (Button) findViewById(R.id.plusBtn5);
		btnArr [5] = (Button) findViewById(R.id.plusBtn6);
		btnArr [6] = (Button) findViewById(R.id.plusBtn7);
		btnArr [7] = (Button) findViewById(R.id.minusBtn1);
		btnArr [8] = (Button) findViewById(R.id.minusBtn2);
		btnArr [9] = (Button) findViewById(R.id.minusBtn3);
		btnArr [10] = (Button) findViewById(R.id.minusBtn4);
		btnArr [11] = (Button) findViewById(R.id.minusBtn5);
		btnArr [12] = (Button) findViewById(R.id.minusBtn6);
		btnArr [13] = (Button) findViewById(R.id.minusBtn7);

		NULL_BTN4  = R.id.nullBtn4;
		NULL_BTN5  = R.id.nullBtn5;
		NULL_BTN6  = R.id.nullBtn6;

		SHORT_DAYS_ID = R.array.ShortDays;
	}

	
	// for creating additional views, see eclipsedroid.Date_Input
	
//	public void createExtraButtons (){	    
//    	LinearLayout ll01 = (LinearLayout) findViewById(R.id.LL01);
//
//		//TODO Add buttons to ll01
//		Button testBtn = new Button (this);
//		testBtn.setText("Test");
//		ll01.addView(testBtn);		
//	}

}  // *************** of class definition



*/

/*****************************************************************************\
 *
 *  Copyright 2019 Dr. Wolfgang Strickling
 *  published under  GNU GPL 3
 *
 *   This file is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 \*****************************************************************************/
 


import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;

import strickling.utils.AstroUtils;
import strickling.utils.DateTimeUtils;
import strickling.utils.FormatterUtils;


import strickling.utils.SystemUtils;
import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.drawable.ColorDrawable;
import android.os.Build;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.text.format.DateFormat;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnTouchListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.strickling.forms.R;


public class Date_Input_Class extends Activity implements TextWatcher, OnTouchListener {
		
		   
	    public void initViews (){
	    	// perhaps restore original language settings

			setContentView(R.layout.date_input);
			jd_Text = findViewById(R.id.JD_TEXT);
			etYear  = findViewById(R.id.input1);
			etMon  	= findViewById(R.id.input2);
			etDay  	= findViewById(R.id.input3);
			etH  	= findViewById(R.id.input4);
			etMin  	= findViewById(R.id.input5);
			etSec  	= findViewById(R.id.input6);
			etTZ  	= findViewById(R.id.input7);
			dateLine= findViewById(R.id.DateLine);
			btnArr [0] = findViewById(R.id.plusBtn1);
			btnArr [1] = findViewById(R.id.plusBtn2);
			btnArr [2] = findViewById(R.id.plusBtn3);
			btnArr [3] = findViewById(R.id.plusBtn4);
			btnArr [4] = findViewById(R.id.plusBtn5);
			btnArr [5] = findViewById(R.id.plusBtn6);
			btnArr [6] = findViewById(R.id.plusBtn7);
			btnArr [7] = findViewById(R.id.minusBtn1);
			btnArr [8] = findViewById(R.id.minusBtn2);
			btnArr [9] = findViewById(R.id.minusBtn3);
			btnArr [10] = findViewById(R.id.minusBtn4);
			btnArr [11] = findViewById(R.id.minusBtn5);
			btnArr [12] = findViewById(R.id.minusBtn6);
			btnArr [13] = findViewById(R.id.minusBtn7);

			NULL_BTN4  	= R.id.nullBtn4;
			NULL_BTN5  	= R.id.nullBtn5;
			NULL_BTN6  	= R.id.nullBtn6;

			SHORT_DAYS_ID = R.array.ShortDays;	    
			
			Button nowBtn  = findViewById(R.id.nowBtn);
			nowBtn.setTransformationMethod(null); // avoid capitalization to UPPERCASE
	    }
		
	    // to be overwritten
		public void createExtraButtons () {	    
//	    	LinearLayout ll01 = (LinearLayout) findViewById(R.id.LL01);

			//TODO Add buttons to ll01
		}

		public static String TAG = "Date_Input";  

		protected static double julDat, zeitZone; //julDat in days, zeitZone in hours should be initialized!
		public static String 	dateTimePattern = DateTimeUtils.DEFAULT_DATETIME_FORM; // May be overwritten
		//public static Locale 	locale = Locale.getDefault();   // May be overwritten
		protected EditText 		jd_Text, etYear, etMon, etDay, etH, etMin, etSec, etTZ;
		protected TextView 		dateLine;
		protected static final  String JD_FORMAT = "%8.6f"; // default %8.6f
		protected static final  String TZ_FORMAT = "%+02.1f";
		protected String  		lastJDStrg;  // For TextChange Listener, Findet heraus, ob JD ge�ndert
		protected boolean 		notListen = true;

		// for long click on +- buttons :
		protected Button [] btnArr = new Button [14]; // Array for +- Buttons
		Timer keyTimer = new Timer (); // enables long click feature
		protected static View keyView;   // buffers the button pressed for updateTask (called by timer)
		protected static boolean timerRunning = false;
		final Runnable updateTask = new Runnable() {
			public void run() {
				timerRunning = true;
				changeClick (keyView); }
		};	    

//		static String dForm = "%02.0f"; // will be replaced in Arabic to "%02.0f" 


		// Store Resource IDs, will be overwritten in initViews
		protected int NULL_BTN4 = 0;
		protected int NULL_BTN5 = 0;
		protected int NULL_BTN6 = 0;
		protected int SHORT_DAYS_ID = 0;
		//protected int LANGUAGE_ID = 0;


		@Override
		public void onCreate(Bundle savedInstanceState) {
			if (Build.VERSION.SDK_INT >= 11)
				setTheme (getIntent().getIntExtra("theme",
						Build.VERSION.SDK_INT >= 21 ? android.R.style.Theme_Material : android.R.style.Theme_Holo)); // set dark theme
			super.onCreate(savedInstanceState);
			initViews();
//			locale = new Locale (getString(LANGUAGE_ID));
//			Locale.setDefault(locale);
			Log.d(TAG, "SUPER Date onCreate, Language def, " +Locale.getDefault().getLanguage() +" locale: " +AstroUtils.locale.getLanguage());

			etTZ.setText(String.format(TZ_FORMAT, zeitZone));
			updateAllFields (julDat, zeitZone);


			// install TextChangeListener after NowBtnClick 
			jd_Text.addTextChangedListener(this); 
			etYear.addTextChangedListener(this);
			etMon.addTextChangedListener(this);
			etDay.addTextChangedListener(this);
			etH.addTextChangedListener(this);
			etMin.addTextChangedListener(this);
			etSec.addTextChangedListener(this);
			etTZ.addTextChangedListener(this);  
			setResult (Activity.RESULT_OK);

			// OnTouchListener install, for Long click
			for (int i = 0; i<14; i++) {btnArr[i].setOnTouchListener(this);}

			createExtraButtons ();
			setResult (Activity.RESULT_CANCELED);			
			
	        // Set blue actionBar with icon, replaces android:theme="@style/ThemeDialogWhenLarge" in manifest activity
	        SystemUtils.configureActionBar (this); 		
			
			// Remove Keyboard
			this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN); 
		}

				
		// Getters and setters are needed to preserve Static fields after rotation
		
		/**
		 * @return julDat in days
		 */
		public static double getJulDat () {
			return julDat;
		}

		public static long getMillis () {
			return DateTimeUtils.julDat2Millis(julDat);
		}

		/** sets  julDat in days
		 */
		public static void setJulDat (double julDat) {
			Date_Input_Class.julDat = julDat;
		}
		
		public static void setMillis (long millis) {
			Date_Input_Class.julDat = DateTimeUtils.millis2JulDat(millis);
		}
		
		/**
		 * @return timeZone in Hours
		 */
		public static double getTimeZone () {
			return zeitZone;
		}

		/** returns timeZone in Hours
		 * 
		 * @param timeZone in Hours
		 */
		public static void setTimeZone (double timeZone) {
			zeitZone = timeZone;
		}

		protected void setDateLine (double julDat, double timeZoneHrs) {  //TODO			
			julDat += DateTimeUtils.JD_ROUND_PREVENTER;
			dateLine.setText(dayOfWeek (julDat, timeZoneHrs).trim() +", "
					+FormatterUtils.zeitStrg(julDat, timeZoneHrs, dateTimePattern, AstroUtils.locale));
		}

		// Catches numerid inputs, if Error: 0
		@SuppressWarnings({ "finally" })
		protected double GetNumeric (TextView tv) {
			double r = 0;
			String s = tv.getText().toString();
			
			
//			if (tv == jd_Text) Log.d(TAG, "   String: " +s);
				s = FormatterUtils.replaceArabic(s).replace(",", ".");      // avoids problems with decimal comma (e.g. German language)
//				if (tv == jd_Text) Log.d(TAG, "   String: " +s);
			try {
				r = Double.valueOf (s);
				return r;
			}
			finally {return r;}
		}

		// display JulDat and dateline
		protected void setJulDat (){
			zeitZone = GetNumeric (etTZ);
			//				ad = new AstroDate ((int) GetNumeric(etDay), 
			julDat  = DateTimeUtils.jdCalc(
					(int) GetNumeric(etYear), 
					(int) GetNumeric(etMon), 
					(int) GetNumeric(etDay), // day may be greater than 31
					(int) GetNumeric(etH), 
					(int) GetNumeric(etMin), 
					GetNumeric(etSec)+0.0,
					zeitZone);
			//	        julDat  = ad.jd(ad) - zeitZone/24.0;
			notListen = true;
			jd_Text.setText(String.format(AstroUtils.locale, JD_FORMAT, julDat +0.0000000));
			// ad neu schreiben, damit keine Daten wie 2010-02-31 entstehen
			//		        ad = new AstroDate (julDat + zeitZone/24.0); 
			setDateLine (julDat, zeitZone);
			notListen = false;
		}


		// Aktualisiert Felder im Fenster
		protected void jdToFields (){
			julDat   = GetNumeric (jd_Text);
			zeitZone = GetNumeric (etTZ);
			updateFields (julDat, zeitZone);
		}

		protected void updateAllFields (double julDat, double zeitZone){
			updateFields (julDat, zeitZone);
			notListen = true;
			jd_Text.setText(String.format(AstroUtils.locale, JD_FORMAT, julDat +0.0000002));
			notListen = false;	    	
		}
		// nur Datumsfelder aktualisieren
		protected void updateFields (double julDat, double timeZone){

			julDat = AstroUtils.roundFloat(julDat, 0.5/86400.0);
			Date_Input_Class.julDat = julDat; // save lokal Variable in Instancevariable
			double [] ymdhms = new double [6];
			DateTimeUtils.jd2YMDHMS(julDat, timeZone, 0, ymdhms);
			notListen = true;
			
			// avoid western leading zeros in eastern Arabic numbers 
			String leadingZero = "%02.0f";
			if (AstroUtils.locale.getLanguage().startsWith("ar")) leadingZero = "%2.0f";
			
			etYear.setText (String.format(AstroUtils.locale, "%.0f", ymdhms[0]));
			etMon.setText  (String.format(AstroUtils.locale, leadingZero, ymdhms[1]));
			etDay.setText  (String.format(AstroUtils.locale, leadingZero, ymdhms[2]));
			etH.setText	   (String.format(AstroUtils.locale, "%.0f", ymdhms[3]));
			etMin.setText  (String.format(AstroUtils.locale, leadingZero, ymdhms[4]));
			etSec.setText  (String.format(AstroUtils.locale, leadingZero, ymdhms[5])); 
			etTZ.setText   (String.format(AstroUtils.locale, TZ_FORMAT,timeZone));
			setDateLine (julDat, zeitZone);
			notListen = false;
		}

		// changes a View field by a certain amount and formats
		void modifyTV (TextView tv, double diff, String formatStrg) {
			double zDouble;
			zDouble = GetNumeric (tv);
			zDouble = zDouble +diff;
			// remain Timezone within -12..+12
			if ((tv == etTZ) && (tv != null)) {
				if (zDouble >=13.)  {zDouble = -12.;}
				if (zDouble <=-13.) {zDouble =  12.;}
			}

			if ((tv == etMon) && (tv != null)) {
				if (zDouble >=13.) {zDouble -= 12.; modifyTV (etYear,  1, "%.0f");}
				if (zDouble <= 0.) {zDouble += 12.; modifyTV (etYear, -1, "%.0f");}
			}
			notListen = true;
			tv.setText(String.format(AstroUtils.locale, formatStrg, zDouble));
			//			    notListen = false; // wird nach Aufruf in changeClick gesetzt
			
		}

		// changeClick wird bei + oder - Button ausgel�st
		public void changeClick (View view) {
			julDat   =AstroUtils.roundFloat(GetNumeric (jd_Text), 0.5/86400.0);
			zeitZone = GetNumeric (etTZ);
			notListen = true;

			// Remove Keyboard
			InputMethodManager inputManager = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
			inputManager.hideSoftInputFromWindow(this.getCurrentFocus().getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS); 			

			if (view == btnArr [0]) {modifyTV (etYear, 1, "%.0f"); setJulDat();}
			if (view == btnArr [7]) {modifyTV (etYear,-1, "%.0f"); setJulDat();}
			if (view == btnArr [1]) {modifyTV (etMon, 1, "%02.0f");  setJulDat();}
			if (view == btnArr [8]) {modifyTV (etMon,-1, "%02.0f");  setJulDat();}
			if (view == btnArr [2]) {updateAllFields (julDat +1.0, zeitZone);}
			if (view == btnArr [9]) {updateAllFields (julDat -1.0, zeitZone);}
			if (view == btnArr [3]) {updateAllFields (julDat +1.0/24.0, zeitZone);}
			if (view == btnArr [10]){updateAllFields (julDat -1.0/24.0, zeitZone);}
			if (view == btnArr [4]) {updateAllFields (julDat +1.0/1440.0, zeitZone);}
			if (view == btnArr [11]){updateAllFields (julDat -1.0/1440.0, zeitZone);}
			if (view == btnArr [5]) {updateAllFields (julDat +1.0/86400.0, zeitZone);}
			if (view == btnArr [12]){updateAllFields (julDat -1.0/86400.0, zeitZone);}

			if (view == btnArr [6]) {modifyTV (etTZ, 1, TZ_FORMAT); setJulDat();}
			if (view == btnArr [13]){modifyTV (etTZ,-1, TZ_FORMAT); setJulDat();}

			notListen = false;

		}


		// long click feature: Touch down
		public boolean onTouch(View view, MotionEvent me) {

			if (me.getAction() == MotionEvent.ACTION_DOWN) {
				keyView = view;
				Log.d(TAG, "Btn down OnClickListener, Timer running: " +timerRunning);
				keyTimer = new Timer("keyTimer");
				keyTimer.schedule(new TimerTask() {
					@Override
					public void run() { runOnUiThread(updateTask); }
				}, 1000, 250);  // delay, interval
				view.setPressed(true);
			}

			if (me.getAction() == MotionEvent.ACTION_UP ) {
				Log.d(TAG, "Btn up OnClickListener, Timer running: " +timerRunning);
				if (keyTimer != null ) {
					keyTimer.cancel();
					keyTimer.purge();
					}
				if (!timerRunning) {changeClick (view);} 
				keyTimer = null;
				timerRunning = false;
				view.setPressed(false);
			}
			return true;//(-me.getDownTime() +me.getEventTime() > 999); 
			// btnClick wird nur ausgel�st, wenn return false!
		}



		public void setNullClick (View view) {
			notListen = true;	   
			String zero = String.format(AstroUtils.locale, "%1d", 0);
			if (view.getId()== NULL_BTN4) {etH.setText (zero); etMin.setText (zero+zero); etSec.setText (zero+zero);}
			if (view.getId()== NULL_BTN5) {etMin.setText (zero+zero); etSec.setText (zero+zero);}
			if (view.getId()== NULL_BTN6) {etSec.setText (zero+zero);}
			setJulDat ();
			notListen = false;	       	
		}

		// Felder auf aktuelle Zeit setzen. 
		// Achtung: Win Emulator setzt auf UTC, Phone auf Local time
		public void nowBtnClick (View view) {
			notListen = true;
			julDat = DateTimeUtils.nowJulDat(); 
			//julDat = DateOps.nowToDoubleDay() -GetCurrentDSTOffset ()/24.0;
			zeitZone = GetNumeric (etTZ);
			updateAllFields (julDat, zeitZone);
			notListen = false;

			// Remove Keyboard
			InputMethodManager inputManager = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
			inputManager.hideSoftInputFromWindow(this.getCurrentFocus().getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);
			okBtnClick (view);
		} 

		public void okBtnClick (View view) {
			//	       		julDat   = GetNumeric (jd_Text);
			setResult (Activity.RESULT_OK);
			//double testJulDat = julDat;
			finish();
		}

		// Auswerten und ggf JulDat oder Datumsfelder aktualisieren
		public void afterTextChanged(Editable s) {
			if (! notListen ){  // only evaluate here, if no automatic change
				//Log.d(TAG, "LastJulDat: " +lastJDStrg +", now: " +jd_Text.getText().toString());
				if (lastJDStrg.equals (jd_Text.getText().toString())) {
					Log.d(TAG, "Field changed, Updating JulDat");
					setJulDat ();
				}  
				else { // JD not changed -> Fields were changed, JD update
					Log.d(TAG, "JulDat changed, Updating Fields, LastJulDat: " +lastJDStrg +", now: " +jd_Text.getText().toString());
					jdToFields (); // JD  manual changed -> Fields update
				}
                lastJDStrg = jd_Text.getText().toString(); // buffers this JD
			} 
		}

		public void beforeTextChanged(CharSequence s, int start, int count,
				int after) {
			lastJDStrg = jd_Text.getText().toString(); // buffers old JD
		}

		public void onTextChanged(CharSequence s, int start, int before,
				int count) {
		}

		public String dayOfWeek (double julDat, double timeZoneHrs) {
//			String dow = new SimpleDateFormat ("EEE", locale).format(
//					new Date ((long)(AstroUtils.realMod(julDat, 7.)+2455950. +(timeZoneHrs -DateTimeUtils.GetCurrentTimeZone())/24.)));	
//			return dow.substring(0, 1).toUpperCase(locale) + dow.substring(1); 

//			return (String) DateFormat.format("E", 
//					(long) (AstroUtils.realMod(julDat, 7.)+2455950. +(timeZoneHrs -DateTimeUtils.GetCurrentTimeZone())/24.));

			Resources res = getResources();
			CharSequence[] daysArray = res.getTextArray(SHORT_DAYS_ID);
			return (String) daysArray [DateTimeUtils.dayOfWeek(julDat, timeZoneHrs)];
		}

}
