package strickling.forms;

/** PermissionChecker subclass including makePermissionsOverwiev
 *  requires Resources com.strickling.forms.R
 */

/*****************************************************************************\
 *
 *  Copyright 2019 Dr. Wolfgang Strickling
 *  published under  GNU GPL 3
 *
 *   This file is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 \*****************************************************************************/
 

import android.Manifest;
import android.app.Activity;
import android.os.Build;
import android.util.Log;
import com.strickling.forms.R;
import strickling.utils.PermissionChecker;

public class PermissionCheckerX extends PermissionChecker {


    public static String makePermissionsOverwiev (Activity activity, String[] permissionList, boolean withGranted) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            String s = "";
            int count = 0;
            for (String per : permissionList) {
//                Log.d (TAG, "Permission: " +per +"  " +hasPermission(activity, per) +"   Count: " +count);
                if (!hasPermission(activity, per)) {
                    if (!s.equals("")) s += "\n";
                    s += per +" " +activity.getString(R.string.denied);
                    count++;
//                    Log.d (TAG, "Permission: " +per +"  not granted   Count: " +count);
                } else if (withGranted) {
                    if (!s.equals("")) s += "\n";
                    s += per +" " +activity.getString(R.string.granted);
                    count++;
//                    Log.d (TAG, "Permission: " +per +"  is  granted   Count: " +count);
                }
            }
            if (count == 1) {
                s = activity.getString(R.string.Permission) + " " +s;
            } else if (count > 1) {
                s = activity.getString(R.string.Permissions) + ":\n" +s;
            }
            s = s.replaceAll(Manifest.permission.ACCESS_COARSE_LOCATION, activity.getString(R.string.pLocation));
            s = s.replaceAll(Manifest.permission.ACCESS_FINE_LOCATION, activity.getString(R.string.pLocation));
            s = s.replaceAll(Manifest.permission.CAMERA, activity.getString(R.string.pCamera));
            s = s.replaceAll(Manifest.permission.READ_CALENDAR, activity.getString(R.string.pCalendar));
            s = s.replaceAll(Manifest.permission.WRITE_EXTERNAL_STORAGE, activity.getString(R.string.pStorage));
            s = s.replaceAll(Manifest.permission.READ_EXTERNAL_STORAGE, activity.getString(R.string.pStorage));
            s = s.replaceAll(Manifest.permission.READ_EXTERNAL_STORAGE, activity.getString(R.string.pLocation));
            s = s.replaceAll("android.permission.", "");
            Log.d(TAG, s);
            return s;
        } else return "";
    }


}
